<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerPackage ArrayType
 * @subpackage Arrays
 */
class ArrayOfCustomerPackage extends AbstractStructArrayBase
{
    /**
     * The CustomerPackage
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\CustomerPackage[]
     */
    public $CustomerPackage;
    /**
     * Constructor method for ArrayOfCustomerPackage
     * @uses ArrayOfCustomerPackage::setCustomerPackage()
     * @param \CustomerManagement\StructType\CustomerPackage[] $customerPackage
     */
    public function __construct(array $customerPackage = array())
    {
        $this
            ->setCustomerPackage($customerPackage);
    }
    /**
     * Get CustomerPackage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\CustomerPackage[]|null
     */
    public function getCustomerPackage()
    {
        return isset($this->CustomerPackage) ? $this->CustomerPackage : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerPackage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerPackage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerPackageForArrayConstraintsFromSetCustomerPackage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerPackageCustomerPackageItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerPackageCustomerPackageItem instanceof \CustomerManagement\StructType\CustomerPackage) {
                $invalidValues[] = is_object($arrayOfCustomerPackageCustomerPackageItem) ? get_class($arrayOfCustomerPackageCustomerPackageItem) : sprintf('%s(%s)', gettype($arrayOfCustomerPackageCustomerPackageItem), var_export($arrayOfCustomerPackageCustomerPackageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomerPackage property can only contain items of type \CustomerManagement\StructType\CustomerPackage, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerPackage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\CustomerPackage[] $customerPackage
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerPackage
     */
    public function setCustomerPackage(array $customerPackage = array())
    {
        // validation for constraint: array
        if ('' !== ($customerPackageArrayErrorMessage = self::validateCustomerPackageForArrayConstraintsFromSetCustomerPackage($customerPackage))) {
            throw new \InvalidArgumentException($customerPackageArrayErrorMessage, __LINE__);
        }
        if (is_null($customerPackage) || (is_array($customerPackage) && empty($customerPackage))) {
            unset($this->CustomerPackage);
        } else {
            $this->CustomerPackage = $customerPackage;
        }
        return $this;
    }
    /**
     * Add item to CustomerPackage value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\CustomerPackage $item
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerPackage
     */
    public function addToCustomerPackage(\CustomerManagement\StructType\CustomerPackage $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\CustomerPackage) {
            throw new \InvalidArgumentException(sprintf('The CustomerPackage property can only contain items of type \CustomerManagement\StructType\CustomerPackage, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomerPackage[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\CustomerPackage|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\CustomerPackage|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\CustomerPackage|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\CustomerPackage|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\CustomerPackage|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerPackage
     */
    public function getAttributeName()
    {
        return 'CustomerPackage';
    }
}
